//	CircQp.hpp

#ifndef __CIRCQP__HPP__
#define __CIRCQP__HPP__


template<class T>
class   CircQuePtr
{
public:
    
    virtual T*    	Add( T* _item ) =0;
    virtual uint	Add( T** _src, uint _qty ) =0;

    virtual T*   	Remove() =0;
    virtual uint   	Remove( T** _dest, uint _qty ) =0;

    virtual T*    	Read( uint& _pos ) =0;
    virtual T*	    ReadX( const uint& _pos ) =0;
    virtual uint   	Read( T** _dest, uint _qty, uint& _pos ) =0;
    virtual uint   	ReadX( T** _dest, uint _qty, const uint& _pos ) =0;

	virtual uint	Count( uint _pos ) const =0;
	virtual uint	Count()	const =0;
	virtual uint	Capacity()	const =0;
	virtual uint	FreeSpace() const =0;
	virtual uint	End() const =0;
	virtual uint	Start() const =0;
};


#endif  // __CIRCQP__HPP__
